; Author:            pablov
; Date:              September 24, 2011
; Update:            October 28, 2013
; OS:                Microsoft Windows
; Compiler:          PureBasic 5.10 and >
;    http://rsdn.ru/article/baseserv/peloader.xml
;########################################################################################
;###                                                                                  ### 
;###                               !!!!!!!                                      ###
;###              DLL  !!!!!!!!!!             ###
;###                                                                                  ###
;########################################################################################
;      ,   
;  PureBasic,    .    LZMA (   )

#IMAGE_REL_BASED_ABSOLUTE = 0
#IMAGE_ORDINAL_FLAG32     = $80000000

;{ Structures 
CompilerIf Defined(IMAGE_SECTION_HEADER, #PB_Structure) = 0
  Structure IMAGE_SECTION_HEADER
    SecName.b[8]
    StructureUnion
      PhysicalAddr.l
      VirtualSize.l
    EndStructureUnion
    VirtualAddress.l
    SizeOfRawData.l
    PointerToRawData.l
    PointerToRelocations.l
    PointerToLinenumbers.l
    NumberOfRelocations.w
    NumberOfLinenumbers.w
    Characteristics.l
  EndStructure
CompilerEndIf

CompilerIf Defined(IMAGE_SECTION_HEADERS, #PB_Structure) = 0
  Structure IMAGE_SECTION_HEADERS
    ish.IMAGE_SECTION_HEADER[64]
  EndStructure
CompilerEndIf

Structure ImageBaseRelocation
    VirtualAddress.l
    SizeOfBlock.l 
EndStructure

Structure _IMAGE_IMPORT_DESCRIPTOR
    OriginalFirstThunk.l
    TimeDateStamp.l                     ;  0,      (binding)
                                        ;         ,  
                                        ;  , :  -1,      
    ForwarderChain.l                    
    Name.l                              ;    ASCIIZ-   ,   
    FirstThunk.l                        ;      
EndStructure

Structure DLL_INFO                      ;  
  BaseVirtDll.l
  EntryPoint.l
  loadDLL.l
EndStructure  
;}

Global Dim LibraryLoad(0)               ;        . DLL
Global DllInfo.DLL_INFO

ProcedureDLL FreeLibraryEx()            ;  dll       
    CallFunctionFast(DllInfo\BaseVirtDll + DllInfo\EntryPoint, DllInfo\BaseVirtDll, #DLL_PROCESS_DETACH, 0)
    For i.w = 0 To DllInfo\loadDLL - 1 
       FreeLibrary_(LibraryLoad(i))
    Next i
    If DllInfo\BaseVirtDll : VirtualFree_(DllInfo\BaseVirtDll, 0, #MEM_RELEASE) :EndIf
EndProcedure

ProcedureDLL GetProcAddressEx(BaseAddress.l, ProcName.s)
    Protected PExports.IMAGE_EXPORT_DIRECTORY
    Protected _step = 0
    Protected *DOS_HEADER.IMAGE_DOS_HEADER             
    Protected *NT_HEADERS.IMAGE_NT_HEADERS
    *DOS_HEADER      = BaseAddress
    *NT_HEADERS      = BaseAddress + *DOS_HEADER\e_lfanew           
    RtlMoveMemory_(PExports, *NT_HEADERS\OptionalHeader\DataDirectory[#IMAGE_DIRECTORY_ENTRY_EXPORT]\VirtualAddress + BaseAddress , SizeOf(IMAGE_EXPORT_DIRECTORY))
    NameAddr.l = PExports\AddressOfNames + BaseAddress
    OrdinalAddres.l = PExports\AddressOfNameOrdinals + BaseAddress
    FuncAddr.l      = PExports\AddressOfFunctions + BaseAddress
    For index.l = 0 To PExports\NumberOfNames - 1
        NameAddr + _step
        OrdinalAddres + _step/2                   ;   ,   Ordinal -> WORD
        If ProcName = PeekS(PeekL(NameAddr) + BaseAddress, #MAX_PATH, #PB_Ascii)
           ProcAddress.l = PeekL(FuncAddr + PeekW(OrdinalAddres)*4 ) + BaseAddress
           Break
        EndIf  
        _step = 4                                 ;   DWORD
    Next index
 ProcedureReturn ProcAddress   
EndProcedure

ProcedureDLL ImportProc(BaseAddress.l, *NT_HEADERS.IMAGE_NT_HEADERS)
  Protected PImport._IMAGE_IMPORT_DESCRIPTOR
  Protected PRVA_Import
  Protected LibsUsed.s   = Space(#MAX_PATH)
  Protected Name_func.s  = Space(#MAX_PATH)
  Protected Name_funcA.s = Space(#MAX_PATH) ; Ascii
  n.w = 0
  If *NT_HEADERS\OptionalHeader\DataDirectory[#IMAGE_DIRECTORY_ENTRY_IMPORT]\VirtualAddress  ;   , 
    SizeImportStruct.b = SizeOf(_IMAGE_IMPORT_DESCRIPTOR)
    RtlMoveMemory_(PImport, *NT_HEADERS\OptionalHeader\DataDirectory[#IMAGE_DIRECTORY_ENTRY_IMPORT]\VirtualAddress + BaseAddress , SizeImportStruct)
    While PImport\FirstThunk <> 0                             ;      

       LibsUsed = PeekS(PImport\Name + BaseAddress, 100, #PB_Ascii)
          hModule = GetModuleHandle_(LibsUsed)
          If hModule = 0                                      ;       
            hModule = LoadLibrary_(LibsUsed)                  ;   
            ReDim LibraryLoad(DllInfo\loadDLL)
            LibraryLoad(DllInfo\loadDLL) = hModule
            DllInfo\loadDLL + 1
          EndIf
          If PImport\TimeDateStamp = 0                        ;  ?          
               PRVA_Import = pImport\FirstThunk + BaseAddress 
          Else 
               PRVA_Import = pImport\OriginalFirstThunk + BaseAddress           
          EndIf
        While PeekL(PRVA_Import) <> 0  ;          
          If PeekL(PRVA_Import) & #IMAGE_ORDINAL_FLAG32 <> 0                       ;    
             PokeL(PRVA_Import, GetProcAddress_(hModule, PeekL(PRVA_Import) & $FFFF))
           Else                                                                     ;    
             Name_func = PeekS(PeekL(PRVA_Import) + 2 + BaseAddress, #MAX_PATH, #PB_Ascii)
             CompilerIf #PB_Compiler_Unicode
                 WideCharToMultiByte_(#CP_ACP, 0, @Name_func, -1, @Name_funcA, #MAX_PATH, #Null, #Null)
                 PokeL(pImport\FirstThunk + n + BaseAddress, GetProcAddress_(hModule, Name_funcA))
             CompilerElse
                 PokeL(pImport\FirstThunk + n + BaseAddress, GetProcAddress_(hModule, Name_func))
             CompilerEndIf
          EndIf 
            n + 4
            PRVA_Import + 4
        Wend
        n = 0
         RtlMoveMemory_(PImport, *NT_HEADERS\OptionalHeader\DataDirectory[#IMAGE_DIRECTORY_ENTRY_IMPORT]\VirtualAddress + BaseAddress + _step.w + SizeImportStruct, SizeImportStruct)
         _step + SizeImportStruct
    Wend
  EndIf
EndProcedure

ProcedureDLL RelocProc(BaseAddress.l, *NT_HEADERS.IMAGE_NT_HEADERS)
  Protected *PReloc.ImageBaseRelocation
  Protected ModCount
  Protected ImageBaseDelta = BaseAddress - *NT_HEADERS\OptionalHeader\ImageBase   ;    
  If ImageBaseDelta     ;    . DLL   ImageBase ( = 0),    
    RelocsSize.l = *NT_HEADERS\OptionalHeader\DataDirectory[#IMAGE_DIRECTORY_ENTRY_BASERELOC]\Size
    *PReloc = *NT_HEADERS\OptionalHeader\DataDirectory[#IMAGE_DIRECTORY_ENTRY_BASERELOC]\VirtualAddress + BaseAddress 
    P.w
    j.l
    tempSize.l = 0
    startAdrReloc = *NT_HEADERS\OptionalHeader\DataDirectory[#IMAGE_DIRECTORY_ENTRY_BASERELOC]\VirtualAddress + BaseAddress + 8
    While tempSize < RelocsSize                                          
       ModCount = (*PReloc\SizeOfBlock - 8) / 2 
       For j = 0 To ModCount-1 
          P = PeekW(startAdrReloc) 
          If P & $f000 <> #IMAGE_REL_BASED_ABSOLUTE
             RelocValue = PeekL(BaseAddress + *PReloc\VirtualAddress + (P & $0fff)) + ImageBaseDelta
             PokeL(BaseAddress + *PReloc\VirtualAddress + (P & $0fff), RelocValue)        ;    
             startAdrReloc + 2
          Else
             startAdrReloc + 2
          EndIf
       Next j  
       tempSize        + *PReloc\SizeOfBlock
       *PReloc         + *PReloc\SizeOfBlock 
       startAdrReloc   + 8
    Wend 
  EndIf
EndProcedure

ProcedureDLL LoadLibraryEx(StartFile.l, EndFile.l, UnpSize.l=98872)
  Protected *DOS_HEADER.IMAGE_DOS_HEADER             
  Protected *SECTION_HEADERS.IMAGE_SECTION_HEADERS  
  Protected BaseVirtDll
  Protected *NT_HEADERS.IMAGE_NT_HEADERS
  Protected SizePakDll =  EndFile - StartFile  
  Protected OutputSize = UnpSize;98872;69632 ;14848     ; !!!!!!!!!!!!      Dll !!!!!!!!!!!!                                       
  *VirtMemOffset = AllocateMemory(OutputSize) 
 ; *VirtMemOffset = VirtualAlloc_(#Null, SizePakDll, 
  FillMemory(*VirtMemOffset, OutputSize)

  ;If PeekW(StartFile) = $005D                 ;     PureBasic(#PB_PackerPlugin_LZMA)
  ;    Result = UncompressMemory(StartFile, SizePakDll, *VirtMemOffset, OutputSize,   #PB_PackerPlugin_LZMA)
  ;    If Not Result
  ;       If *VirtMemOffset : FreeMemory(*VirtMemOffset) : EndIf  
  ;       ProcedureReturn 0 
  ;     EndIf  
  ;ElseIf PeekW(StartFile) = $5A4D                           ;    ( "MZ")
  If PeekW(StartFile) = $5A4D  
    ; *VirtMemOffset =  AllocateMemory(SizePakDll) 
      MoveMemory(StartFile, *VirtMemOffset, SizePakDll)     ;    
  Else
      MessageRequester("Error", " No valid PE File  ", #MB_OK|#MB_ICONERROR)
      ProcedureReturn 0
  EndIf   
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@    DLL      @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
   ;   
   *DOS_HEADER      = *VirtMemOffset
   *NT_HEADERS      = *VirtMemOffset + *DOS_HEADER\e_lfanew           
   *SECTION_HEADERS = *NT_HEADERS\OptionalHeader + *NT_HEADERS\FileHeader\SizeOfOptionalHeader 
   ;     dll
   BaseVirtDll = VirtualAlloc_(#Null, *NT_HEADERS\OptionalHeader\SizeOfImage, #MEM_COMMIT, #PAGE_EXECUTE_READWRITE)
   If BaseVirtDll  
      DllInfo\EntryPoint = *NT_HEADERS\OptionalHeader\AddressOfEntryPoint
      ;  PE Header ()
      ;   ,    ,      , 
      ; ..      .     BASS.dll
 
      RtlMoveMemory_(BaseVirtDll, *VirtMemOffset, *NT_HEADERS\OptionalHeader\SizeOfHeaders)       
      ;    
      For i = 0 To *NT_HEADERS\FileHeader\NumberOfSections - 1 
         RtlMoveMemory_(BaseVirtDll + *SECTION_HEADERS\ish[i]\VirtualAddress, *VirtMemOffset  + *SECTION_HEADERS\ish[i]\PointerToRawData, *SECTION_HEADERS\ish[i]\SizeOfRawData)      
      Next i
      RelocProc(BaseVirtDll, *NT_HEADERS)                       ;       
 
      ImportProc(BaseVirtDll, *NT_HEADERS)                      ;   
   
    ; @@@@@@@@@@@@@@@@@@@@@@@@@@       @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@  
       For i = 0 To *NT_HEADERS\FileHeader\NumberOfSections - 1
          SC.l = *SECTION_HEADERS\ish[i]\Characteristics
          protect.l = #PAGE_READONLY
          If  SC & $80000000 : protect = #PAGE_READWRITE  : EndIf           
          If  SC & $20000000 : protect = #PAGE_EXECUTE_READ : EndIf         
          If  SC & $20000000 And SC & $80000000 : protect = #PAGE_EXECUTE_READWRITE : EndIf
          VirtualProtect_(*SECTION_HEADERS\ish[i]\VirtualAddress + BaseVirtDll, *SECTION_HEADERS\ish[i]\VirtualSize, protect, @TempAddr.l) 
       Next i 
    ; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@      DLL    @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
       If DllInfo\EntryPoint                       ;  DllMain 

         If CallFunctionFast(BaseVirtDll + *NT_HEADERS\OptionalHeader\AddressOfEntryPoint, BaseVirtDll, #DLL_PROCESS_ATTACH, 0)
         Else
           FreeLibraryEx()
           ProcedureReturn 0
         EndIf
       EndIf
    ; @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
       If *VirtMemOffset : FreeMemory(*VirtMemOffset) : EndIf   
       DllInfo\BaseVirtDll = BaseVirtDll             
    ProcedureReturn BaseVirtDll
 EndIf
    If *VirtMemOffset : FreeMemory(*VirtMemOffset) : EndIf  
    ProcedureReturn 0
EndProcedure
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 182
; FirstLine = 174
; Folding = --
; EnableUnicode
; EnableThread
; EnableXP
; CurrentDirectory = C:\PureBasic5\
; CompileSourceDirectory